Subject: bug#48365: 13.0.11; Dollars in distinct comments trigger math mode highlighting in text in-between

From: Tassilo Horn <[email-masked]>
Date: Wed, 12 May 2021 09:44:42 +0200

jfbu <[email-masked]> writes:

> It is now revealed you are only one entity (perhaps an A.I. based on
> quantum computing) pretending to be two humans only to justify
> coverage of all time zones !

Gosh, we're uncovered!

> But I notice something weird when comparing effect on those two files
>
> File A behaves as expected
> % -*- mode: latex; -*-
> %
> \def\foo_with_underscore{}
> \newcommand\foo{$}%
> % a comment
> A foo_bar^bar{$}
> % a comment
> B foo_bar^bar{$}
> % a comment
> C foo_bar^bar
> $
> %
> %
>
> File B seems to have a problem
> % -*- mode: latex; -*-
> %
> \def\foo_with_underscore{}
> \newcommand\foo{$}%$
> % a comment
> A foo_bar^bar{$}
> % a comment
> B foo_bar^bar{$}
> % a comment
> C foo_bar^bar
> $
> %
> %
>
> In case of file B, which differs only by an added %$ at end of the
> \newcommand line, the \newcommand for example is not highlighted and
> the B line changes colors without applying script style, see
> screenshot

Yeah, it appears that if math mode goes out of hands, it may also have
effects on the fontification before.  That has been the case already
before the latest commits.

But if you just add a space before the \newcommand and delete it again
to trigger re-fontification, it becomes fontified correctly.  Not sure
why that is.  I'll have a look when I find some spare time...

Bye,
Tassilo